/* objops.h
 * header file for operations to objects
 *
 * for Denemo, a gtk+ frontend to GNU Lilypond
 * (c) 1999-2005 Matthew Hiller
 */
#ifndef OBJOPS_H
#define OBJOPS_H 

#include <denemo/denemo.h>

void
freeobject (DenemoObject *mudobj);

DenemoObject *
newtimesigobj (gint time1, gint time2);

DenemoObject *
newclefobj (enum clefs type);

void
initkeyaccs (gint *accs, gint number);

DenemoObject *
newkeyobj (gint number, gint isminor, gint mode); /* default mode: 0 */

DenemoObject *
newmeasurebreakobject ();

DenemoObject *
newstaffbreakobject ();

DenemoObject *
clone_object (DenemoObject * orig);

DenemoObject *
stem_directive_new (enum stemdirections type);

DenemoObject *
lily_directive_new (gchar* type);

DenemoObject *
dynamic_new (gchar *type);

DenemoObject *
lyric_new(gchar *type, gint position, gboolean syllable);

/* create one DenemoObject of type not known to denemo otherwise 
*  no object is associated. */
DenemoObject *
newobj(DenemoObjType type);


void setinitialkeysig(DenemoStaff *curstaff, gint tokey, gint type);
#endif
